%Assignment: CIS 581
%Write a Matlab program that creates a Movie
%Siddu , siddu@temple.edu

function [aviFileName] = SpeedKar

%create avi file
framesPerSec = 30; 
aviFileName = 'SpeedKar';
aviobj = avifile(aviFileName,'fps',framesPerSec,'COMPRESSION','RLE'); 

%Read the start image
simage = imread('start.bmp');

for i = 1:45
    frameObj = im2frame(simage,gray(256));  
    aviobj = addframe(aviobj,frameObj);
end

%Read the track image
wimage = imread('track.bmp');
for i = 1:30
    frameObj = im2frame(wimage,gray(256));  
    aviobj = addframe(aviobj,frameObj);
end

%parameters to move the cars
    moveup =  -5;
    moveupslow = -2
    moveupfast = -8
    moveright = 5;
    moverightslow = 2
    moverightfast = 8
    movedown = 5;
    movedownslow = 2
    movedownfast = 8
    moveleft = -5;
    moveleftslow = -2
    moveleftfast = -8

 % for loop to simulate the game  
 
 for i= 2:766
        
 %Find the cars to make them move
    [Car1Rows,Car1Cols] = find(wimage == 0);
    [Car2Rows,Car2Cols] = find(wimage == 170);
    [Car3Rows,Car3Cols] = find(wimage == 149);
    [Car4Rows,Car4Cols] = find(wimage == 106);
    
 %Clear the cars from the track as it moves 
    for j=1:size(Car1Rows,1)
        wimage(Car1Rows(j),Car1Cols(j)) = 255;
    end
    
    for j=1:size(Car2Rows,1)
        wimage(Car2Rows(j),Car2Cols(j)) = 255;
    end
    for j=1:size(Car3Rows,1)
        wimage(Car3Rows(j),Car3Cols(j)) = 255;
    end
    for j=1:size(Car4Rows,1)
        wimage(Car4Rows(j),Car4Cols(j)) = 255;
    end
        
% make the simulations of the game , move the cars    
        if i <=21 
            newCar1Rows = Car1Rows + moveup;
            newCar1Cols = Car1Cols  ;
            newCar2Rows = Car2Rows + moveup;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows + moveup;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveup;
            newCar4Cols = Car4Cols  ;
            
        elseif i > 21 & i <=60
            newCar1Rows = Car1Rows;
            newCar1Cols = Car1Cols + moveleft;
            newCar2Rows = Car2Rows + moveupslow;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows + moveupslow;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveupslow;
            newCar4Cols = Car4Cols  ;
        elseif i > 60 & i <=67
            newCar1Rows = Car1Rows + movedown;
            newCar1Cols = Car1Cols ;
            newCar2Rows = Car2Rows + moveupslow;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows + moveupslow;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveupslow;
            newCar4Cols = Car4Cols  ;
            
        elseif i>67 & i < 86
            newCar1Rows = Car1Rows + movedown;
            newCar1Cols = Car1Cols ;
            newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moveleft ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols + moveleft ;
            
         elseif i>86 & i < 91
            newCar1Rows = Car1Rows + movedownfast;
            newCar1Cols = Car1Cols ;
            newCar2Rows = Car2Rows + movedown;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols  + moveleft;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols  + moveleft;      
            
         elseif i>91 & i < 116
             newCar1Rows = Car1Rows + movedownfast;
             newCar1Cols = Car1Cols ;
             newCar2Rows = Car2Rows + movedown;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + movedown;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + movedown;
            newCar4Cols = Car4Cols  ; 
            
          elseif i>116 & i < 157
             newCar1Rows = Car1Rows ;
             newCar1Cols = Car1Cols + moverightfast;
             newCar2Rows = Car2Rows + movedown;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + movedown;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + movedown;
            newCar4Cols = Car4Cols  ;
            
          elseif i>157 & i < 162
             newCar1Rows = Car1Rows ;
             newCar1Cols = Car1Cols + moverightfast;
             newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moverightslow;
            newCar3Rows = Car3Rows + movedown;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + movedown;
            newCar4Cols = Car4Cols  ; 
            
        elseif i>162 & i < 170
             newCar1Rows = Car1Rows ;
             newCar1Cols = Car1Cols + moverightfast;
             newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moverightslow;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols +moveright ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols + moveright ; 
            
        elseif i>170 & i < 187
             newCar1Rows = Car1Rows + moveup;
             newCar1Cols = Car1Cols ;
             newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moverightslow +1;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols +moveright ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols + moveright ; 
            
        elseif i>187 & i < 232
             newCar1Rows = Car1Rows + moveup - 1;
             newCar1Cols = Car1Cols ;
             newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moveright;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols +moveright ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols + moveright - 1; 
            
        elseif i>232 & i < 253
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveright;
             newCar2Rows = Car2Rows ;
            newCar2Cols = Car2Cols + moveright + 1;
            newCar3Rows = Car3Rows + moveupfast;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols + moverightslow - 1; 
            
        elseif i>253 & i < 272
             newCar1Rows = Car1Rows + movedownfast ;
             newCar1Cols = Car1Cols ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + moveup;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveup ;
            newCar4Cols = Car4Cols  ; 
            
        elseif i>272 & i < 292
             newCar1Rows = Car1Rows + moveupfast ;
             newCar1Cols = Car1Cols ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + moveup;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols  ;
            
            elseif i>292 & i < 324
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moverightfast ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast ;
            newCar4Rows = Car4Rows + moveup + 2 ;
            newCar4Cols = Car4Cols  ;
            
        elseif i>324 & i < 335
             newCar1Rows = Car1Rows + movedownfast ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols + moverightslow;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moveright ;
            
        elseif i>335 & i < 351
             newCar1Rows = Car1Rows + movedownfast ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols + moverightslow;
            newCar3Rows = Car3Rows + movedownfast;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moveright  ;  
            
        elseif i>351 & i < 362
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols + moveright;
            newCar3Rows = Car3Rows + movedownfast;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moverightfast  ;
            
        elseif i>362 & i < 365
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols + moverightslow;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleftfast ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moverightfast + 5   ;
            
        elseif i>365 & i < 384
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows + movedown ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft ;
            newCar4Rows = Car4Rows + movedownfast ;
            newCar4Cols = Car4Cols   ;  
            
        elseif i>384 & i < 403
             newCar1Rows = Car1Rows + movedownfast ;
             newCar1Cols = Car1Cols   ;
             newCar2Rows = Car2Rows + movedownfast ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft ;
            newCar4Rows = Car4Rows + movedownfast ;
            newCar4Cols = Car4Cols   ;
            
        elseif i>403 & i < 410
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveleftfast  ;
             newCar2Rows = Car2Rows + movedownfast ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft ;
            newCar4Rows = Car4Rows + movedownfast;
            newCar4Cols = Car4Cols    ;
            
        elseif i>410 & i < 431
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moveleftfast  ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + moveup;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols  + moveleftfast  ;
            
        elseif i>431 & i < 450
             newCar1Rows = Car1Rows + moveupfast ;
             newCar1Cols = Car1Cols   ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows + moveup;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols  + moveleftfast  ;
            
        elseif i>450 & i < 467
             newCar1Rows = Car1Rows + moveupfast ;
             newCar1Cols = Car1Cols   ;
             newCar2Rows = Car2Rows + moveup - 1;
            newCar2Cols = Car2Cols ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveright ;
            newCar4Rows = Car4Rows ;
            newCar4Cols = Car4Cols  + moveleftfast  ; 
            
        elseif i>467 & i < 497
             newCar1Rows = Car1Rows + moveup ;
             newCar1Cols = Car1Cols   ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleft;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveright ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols   ;
            
        elseif i>497 & i < 505
             newCar1Rows = Car1Rows + moveup ;
             newCar1Cols = Car1Cols   ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast;
            newCar3Rows = Car3Rows + moveupfast ;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols   ;  
            
        elseif i>505 & i < 514
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moverightfast  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast - 3;
            newCar3Rows = Car3Rows + moveupfast ;
            newCar3Cols = Car3Cols  ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols   ; 
            
        elseif i>514 & i < 521
             newCar1Rows = Car1Rows  ;
             newCar1Cols = Car1Cols + moverightfast  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols   ;
            
        elseif i>521 & i < 529
             newCar1Rows = Car1Rows + moveupfast  ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows + moveupfast ;
            newCar4Cols = Car4Cols   ;  
            
        elseif i>529 & i < 535
             newCar1Rows = Car1Rows + moveupfast  ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moverightfast  ; 
            
        elseif i>535 & i < 545
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moverightfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveleftfast ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows  ;
            newCar4Cols = Car4Cols + moverightfast  ; 
            
        elseif i>545 & i < 558
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moverightfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveright ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleft  ;
            newCar4Rows = Car4Rows + moveupfast  ;
            newCar4Cols = Car4Cols  ;
            
        elseif i>558 & i < 567
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moverightfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveright ;
            newCar3Rows = Car3Rows  ;
            newCar3Cols = Car3Cols + moveleft  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moverightfast ;
            
        elseif i>567 & i < 579
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moverightfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveright ;
            newCar3Rows = Car3Rows + moveupfast ;
            newCar3Cols = Car3Cols   ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moverightfast ;
            
        elseif i>579 & i <= 580
             newCar1Rows = Car1Rows  + movedownfast ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveright ;
            newCar3Rows = Car3Rows + moveup  ;
            newCar3Cols = Car3Cols   ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moverightfast ;
            
        elseif i>580 & i < 592
             newCar1Rows = Car1Rows + movedownfast  ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moverightslow ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moverightfast ;
            
            
        elseif i>592 & i < 603
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moverightslow ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moverightfast ;
            
        elseif i>603 & i < 616
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moverightslow ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast  ;
            newCar4Rows = Car4Rows + movedownfast  ;
            newCar4Cols = Car4Cols  ;
            
        elseif i>616 & i < 623
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moverightslow ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moverightfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleftfast ;  
            
        elseif i>623 & i < 633
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows;
            newCar2Cols = Car2Cols + moveright + 1;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleftfast ;    
            
        elseif i>633 & i < 643
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows + moveupslow ;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleftfast ; 
            
            
        elseif i>643 & i < 668
             newCar1Rows = Car1Rows   ;
             newCar1Cols = Car1Cols + moveleftfast  ;
             newCar2Rows = Car2Rows + moveupslow ;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleft  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleft ; 
            
        elseif i>668 & i < 678
             newCar1Rows = Car1Rows + moveupfast   ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows + moveup ;
            newCar2Cols = Car2Cols  ;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleft ;
            
        elseif i>678 & i < 682
             newCar1Rows = Car1Rows + moveupfast   ;
             newCar1Cols = Car1Cols  ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols  + moveleftfast;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleftfast ; 
            
        elseif i>682 & i < 705
             newCar1Rows = Car1Rows    ;
             newCar1Cols = Car1Cols + moveleftfast ;
             newCar2Rows = Car2Rows  ;
            newCar2Cols = Car2Cols  + moveleftfast;
            newCar3Rows = Car3Rows ;
            newCar3Cols = Car3Cols + moveleftfast  ;
            newCar4Rows = Car4Rows   ;
            newCar4Cols = Car4Cols + moveleftfast ; 

       end
    
%paint the cars in the new translated co-ordinates    

    for k=1:size(newCar1Rows,1)
        wimage(newCar1Rows(k),newCar1Cols(k)) = 0;
    end
    for j=1:size(newCar2Rows,1)
        wimage(newCar2Rows(j),newCar2Cols(j)) = 170;
    end
    for j=1:size(newCar3Rows,1)
        wimage(newCar3Rows(j),newCar3Cols(j)) = 149;
    end
    for j=1:size(newCar4Rows,1)
        wimage(newCar4Rows(j),newCar4Cols(j)) = 106;
    end
    
    frameObj = im2frame(wimage,gray(256));  
    aviobj = addframe(aviobj,frameObj);
    
end


for i = 1:30
    frameObj = im2frame(wimage,gray(256));  
    aviobj = addframe(aviobj,frameObj);
end

%Game over image
eimage = imread('end.bmp');
for i = 1:45
    frameObj = im2frame(eimage,gray(256));  
    aviobj = addframe(aviobj,frameObj);
end

aviobj = close(aviobj);
return;